<?php
/**
 * Created by PhpStorm.
 * User: Pro
 * Date: 02.12.2015
 * Time: 14:29
 * Short codes wp functions
 */

add_shortcode( 'mycity_top_promo_bloc', 'mycity_top_promo_bloc_func' );

/**
 * @param $atts
 *
 * @return string
 */
function mycity_top_promo_bloc_func( $atts ) {
	$atts = shortcode_atts(
		array(
			'h'      => esc_html__( 'welcome to my city guide!', "mycity" ),
			'desc'   => esc_html__( 'See and visit interesting places. Share experiences with your friends. Simply', "mycity" ),
			'find'   => esc_html__( "Find places or events", "mycity" ),
			'sc'     => esc_html__( 'Select category', 'mycity' ),
			'search' => esc_html__( "Search", "mycity" )
		), $atts
	);
	ob_start();
	?>
	<div class="top_promo_block" id="promo_head">
		<div class="section-bg-overlay infinite-background above-bg"></div>
		<script>
			jQuery('#promo_head').css({
				height: jQuery(window).height() + 'px'
			});
			winHeight = jQuery(window).height();
			jQuery('#hero-bg').height(winHeight + 30);
		</script>
		<div class="start_descrition">
			<h1>
				<hi><?php echo esc_html( $atts['h'] ); ?></hi>
				<span id='ispan'></span></h1>
			<span><?php echo esc_html( $atts['desc'] ); ?></span>

			<div class="search_promo">
				<form action='<?php  echo esc_url(get_home_url('/'))?>/places' method='post'>
					<div class="input-group">
						<input id="search_cat_hide" type="hidden" value="" name="cat_slug"/>
						<input type="text" name='search'
						       placeholder="<?php echo esc_html( $atts['find'] ); ?>"
						       class="form-control">

						<div class="input-group-btn btn_cat">
							<button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown"
							        aria-expanded="false">
                                <span><a data-catis="-1"></a> <i class="fa fa-caret-square-o-down"></i>
	                                <?php echo esc_html( $atts['sc'] ); ?>
	                                <span class="caret"></span></span>
							</button>
							<ul class="dropdown-menu dropdown-menu-right place_dd" role="menu">
								<?php
								$mycity_categories = get_categories( "taxonomy=places_categories&hide_empty=0" );
								foreach ( $mycity_categories as $mycity_place_cat ) {
									?>
									<li><a href="#" data-catis="<?php echo esc_attr( $mycity_place_cat->term_id ); ?>"
									       class="cinema"><i
												class="fa <?php echo esc_html( get_option( "fa_icon_" . (int) $mycity_place_cat->term_id ) ); ?>"></i><?php echo esc_html( $mycity_place_cat->name ); ?>
										</a></li>
									<?php
								}
								?>
							</ul>
						</div>
						<div class="input-group-btn btn_promo_search">
							<button type="submit"
							        class="btn btn-success"><?php echo esc_html( $atts['search'] ); ?></button>
						</div>
					</div>
				</form>

			</div>
		</div>
		<div class="scroll_block">
			<img src="<?php echo esc_url( get_template_directory_uri() ); ?>/img/scroll.png"
			     class="animated infinite bounce" alt="<?php esc_html_e( "Use your scrollwheel :)", "mycity" ); ?>">
		</div>
	</div>
	<?php
	return ob_get_clean();
}

add_shortcode( 'mycity_item_wide', 'mycity_item_wide_func' );
/*
 *
 */
function mycity_item_wide_func( $atts, $content ) {
	$content = ( ! empty( $content ) ) ? $content : "";
	$atts    = shortcode_atts(
		array(
			'h' => esc_html__( 'Features My City', 'mycity' ),
		), $atts
	);
	ob_start();
	?>
	<div class="item_wide_container">
	<div class="fea_block container-fluid">
		<div class="fixed_w">
			<h2><?php echo esc_html__( $atts['h'] ); ?></h2>

			<div class="row">
				<?php
				//get all shortcode
				preg_match_all( '/\[.*?\[\/.*?\]/', $content, $math );
				foreach ( $math[0] as $item ) {
					echo do_shortcode( $item );
				}

				?>
			</div>
		</div>
	</div>

	<?php

	return ob_get_clean();
}

add_shortcode( 'mycity_features_block', 'mycity_mycity_features_block_func' );

function mycity_mycity_features_block_func( $atts, $content = '' ) {
	$atts  = shortcode_atts(
		array(
			'h'    => esc_html__( 'features block', 'mycity' ),
			'icon' => 'fa-mobile'
		), $atts
	);
	$class = ( preg_match( '/fmr/', $atts['icon'] ) ) ? "fmr" : "fa";
	ob_start();
	?>
	<div class="col-md-4 fea_item wow bounceInUp">
		<h3>
			<i class="<?php echo esc_attr( $class . " " . $atts['icon'] ); ?>"></i><?php echo esc_html( $atts['h'] ); ?>
		</h3>
		<span><?php echo wp_kses_post( $content ); ?></span>
	</div>
	<?php
	return ob_get_clean();
}

//categori_block
add_shortcode( 'mycity_categori_block', 'mycity_categori_block_func' );
/**
 * @param $atts
 *
 * @return string
 */
function mycity_categori_block_func( $atts ) {
	$atts = shortcode_atts(
		array(
			'h'   => esc_html__( 'We know all the places in your city', 'mycity' ),
			'btn' => esc_html__( 'View all places', 'mycity' ),
		), $atts
	);
	ob_start();
	?>
	<div class="categori_block container-fluid">
		<div class="fixed_w">
			<h2><?php echo esc_html( $atts['h'] ); ?></h2>

			<div class="row">
				<?php
				$mycity_categories = get_categories( "parent=0&taxonomy=places_categories&hide_empty=0" );

				foreach ( $mycity_categories as $mycity_place_cat ) {
					$class = ( preg_match( '/fmr/', get_option( "fa_icon_" . (int) $mycity_place_cat->term_id ) ) ) ? "fmr" : "fa";
					?>
					<div class="col-md-3 cat_item wow bounceInLeft">
						<div class="car_item_in" onclick="location.href='<?php
						$link = get_term_link( $mycity_place_cat );
						if ( ! isset( $link["errors"] ) ) {
							echo esc_url( $link );
						}

						?>';">
							<i class=" <?php echo esc_html( $class . ' ' . get_option( "fa_icon_" . (int) $mycity_place_cat->term_id ) ); ?>"></i>
							<h4><?php echo esc_html( $mycity_place_cat->name ); ?></h4>
						</div>
					</div>

					<?php
				}
				?>
			</div>
			<a href="/places" class="btn btn-success va"><?php echo esc_html( $atts['btn'] ); ?></a>
		</div>
	</div>
	<?php
	return ob_get_clean();

}

//map
add_shortcode( 'mycity_map', 'mycity_map_func' );
/**
 * @param $atts
 *
 * @return string
 */
function mycity_map_func( $atts ) {
	$atts = shortcode_atts(
		array(
			'h' => esc_html__( 'View full place catalog', 'mycity' ),
		), $atts
	);
	$short_return = "";
	ob_start();

	?>
	<div class="map_block container-fluid">
	<div class="map_descr">
		<span><?php echo esc_html( $atts['h'] ); ?></span>
	</div>

<script>
    var
        mapObject,
        markers = [],
        markersData = {
        <?php
       	$short_return  = ob_get_clean();

		$mycity_categories=  get_categories("taxonomy=places_categories&hide_empty=0");
		$places_categories = array();

		foreach ($mycity_categories  as $mycity_place_cat) {
			$mycity_init_maps_point_by_term_slug = mycity_init_maps_point_by_term_slug($mycity_place_cat->term_id);
			if (!$mycity_init_maps_point_by_term_slug) continue;

              $places_categories[] = "'" . esc_html($mycity_place_cat->slug)."': [".  print_r($mycity_init_maps_point_by_term_slug,true) ."]";
        }

       	$short_return  .= implode(",",$places_categories);
		ob_start();
        ?>
        };
    var global_scrollwheel = false;
    var global_drag = false;

    function initialize_map() {
        loadScript("<?php echo esc_url( get_template_directory_uri() ); ?>/js/infobox.js",after_load);
    }

    function after_load() {

        var global_scrollwheel = true;
        var markerClusterer = null;
        var markerCLuster;
        var Clusterer;

        initialize_new();

    }
</script>
<div class="index_map" id="map"></div>


	</div>
	<?php
		$short_return  .= ob_get_clean();
	return 	$short_return;

}



/*
 * Users blocks-
 */


add_shortcode( 'mycity_users_blocks', 'mycity_users_blocks_func' );
/**
 * @param $atts
 *
 * @return string
 */
function mycity_users_blocks_func( $atts ) {
	global $wpdb;
	$atts = shortcode_atts(
		array(
			'h' => esc_html__( 'The best user weekly', 'mycity' ),
		), $atts
	);
	ob_start();
	?>
	<!--Users blocks-->
	<div class="user_block container-fluid">
		<div class="fixed_w">
			<h2><?php echo esc_html( $atts['h'] ); ?></h2>

			<div class="row">
				<?php
				do_action( 'bp_before_directory_members_list' );

				?>
				<?php
				$blogusers = get_users( 'orderby=registered&number=4' );
				foreach ( $blogusers as $user ) {
					//get commments count

					$comment_counts = (array) $wpdb->get_results( $wpdb->prepare( "SELECT user_id, COUNT( * ) AS total FROM {$wpdb->comments}
        WHERE comment_approved = 1 AND user_id = '%d'
		GROUP BY user_id",
						$user->ID
					), object );

					$followers_count = (array) $wpdb->get_results( $wpdb->prepare( "SELECT COUNT( * ) AS total FROM follow	WHERE user2 = '%d'", $user->ID
					), object );
					?>
					<div class="col-md-3 user_cover wow bounceInLeft">
						<div class="user_item">
							<div class="user_item_cont">
								<img src="<?php
								$params  = array( 'width' => 100, 'height' => 100 );
								$img_url = bfi_thumb( mycity_get_url_by_avatar( get_avatar( $user->ID, 66 ) ), $params );
								echo esc_url( $img_url ); ?>" alt="#">
								<a href="<?php echo mycity_get_member_permalink( $user->ID ); ?>"
								   class="names"><?php echo esc_html( $user->display_name ); ?></a>

								<div class="bottom_link">
									<ul>
										<li><a href="<?php echo mycity_get_member_permalink( $user->ID ); ?>"><i
													class="fa fa-thumbs-o-up"></i><?php echo esc_html( get_user_meta( $user->ID, "folowing", true ) ); ?>
											</a></li>
										<li><a href="<?php echo mycity_get_member_permalink( $user->ID ); ?>"><i
													class="fa fa-comment-o"></i><?php if ( isset( $comment_counts[0]->total ) ) {
													echo esc_html( $comment_counts[0]->total );
												} ?></a></li>
										<li><a href="<?php echo mycity_get_member_permalink( $user->ID ); ?>"><i
													class="fa fa-users"></i><?php echo esc_html( $followers_count[0]->total ); ?>
											</a></li>
										<li class="last"><a
												href="<?php echo mycity_get_member_permalink( $user->ID ); ?>"><i
													class="fa fa-map-marker"></i>0</a></li>
									</ul>
								</div>
							</div>
							<?php
							$user_date = get_userdata( $user->ID )->data;
							$site      = sanitize_text_field( $user_date->user_url );

							if ( $site ) {
								?>
								<a href="<?php echo esc_html( $site ); ?>" class="fb_btn"><i
										class="fa fa-facebook-official"></i></a>
							<?php } ?>

							<img
								src="<?php echo esc_url( mycity_get_url_by_avatar( get_avatar( $user->ID, 100 ) ) ); ?>"
								class="blurbg" alt="">
						</div>
					</div>
				<?php }

				?>

			</div>

			<?php
			$n         = 0;
			$blogusers = get_users( 'orderby=registered&offset=4&number=12' );
			foreach ( $blogusers as $user ) { ?>
				<div class="user_sm col-md-1 wow bounceInRight"
				     onclick="location.href='<?php echo mycity_get_member_permalink( $user->ID ); ?>';">
					<span class="user_num"><?php echo esc_attr( $n ++ ); ?></span>

					<div class="min_u_hover">
						<div class="user_go">
							<i class="fa fa-link"></i>
						</div>
						<img src="<?php
						$params  = array( 'width' => 66, 'height' => 66 );
						$img_url = bfi_thumb( mycity_get_url_by_avatar( get_avatar( $user->ID, 66 ) ), $params );
						echo esc_url( $img_url ); ?>" alt="#">
					</div>
				</div>
				<?php
			}
			?>

		</div>
	</div>


	<?php
	return ob_get_clean();
}

///places_block

add_shortcode( 'mycity_places_block', 'mycity_places_block_func' );
/**
 * @param $atts
 *
 * @return string
 */
function mycity_places_block_func( $atts ) {

	global $wpdb;
	$atts = shortcode_atts(
		array(
			'h' => esc_html__( 'The best user weekly', 'mycity' ),
			'btn' =>  esc_html__( 'View all places', 'mycity' ),
		), $atts
	);
	ob_start();
	?>
<div class="places_index_block container-fluid">
  <div class="fixed_w">
    <h2><?php echo  esc_html( $atts['h'] ); ?></h2>
    <div class="row">
	<?php

    wp_reset_postdata() ;
    global $MyCity_class , $post;
	$args = array(
    'post__not_in' => $MyCity_class->get_empty_places(),
		'post_type' => array(
			'places'
		),
         'posts_per_page' => 100,
		 'orderby' => 'id',
		 'order'=>'desc'
	);


$related_post = new WP_Query($args);

$j= 0;
 if ($related_post->have_posts()) {
      while ($related_post->have_posts()) {
         $related_post->the_post();
         //var_dump($related_post);

         $big_img = wp_get_attachment_url(  get_post_meta((int)$post->ID, '_big_img', true) );
         $big_img  = bfi_thumb($big_img, array(  'width' => 360, 'height' =>210 ));

         if(strlen($big_img) > 0 && $j < 3) {
         $except = (get_post_meta(get_the_ID(), 'smalldescr', true)) ? (get_post_meta(get_the_ID(), 'smalldescr', true)) : get_the_excerpt();

        ?>
        <div class="col-xs-12 col-sm-12 col-md-4 place_index_item  wow bounceInLeft">
            <div class="place_inn">
                <div class="place_indexImg">
                     <img src="<?php  echo esc_url($big_img); ?>" alt="<?php the_title(); ?>">
                </div>
          <div class="pl_descr">
            <a href="<?php  echo esc_url(get_the_permalink()); ?>"><?php  the_title(); ?></a>
            <span>
                <?php echo str_replace(array('<p>','</p>'),array('',''),  $except); ?>
            </span>
			<?php
			mycity_stars(4);
			?>
          </div>
        </div>
      </div>
    <?php $j++;
        }
	  }
	}
	wp_reset_postdata();
	?>
    </div>
    <a href="<?php echo esc_url(get_post_type_archive_link("places"));?>" class="btn btn-success va">
    <?php echo esc_html( $atts['btn'] ); ?></a>
  </div>
</div>
	<?php
	return ob_get_clean();
}
/*********************************Buttons for WordPress TinyMCE Editor*///////////////////////////////////////////////*

// Filter Functions with Hooks
function custom_mce_button() {
  // Check if user have permission
  if ( !current_user_can( 'edit_posts' ) || !current_user_can( 'edit_pages' ) ) {
    return;
  }
  // Check if WYSIWYG is enabled
  if ( 'true' == get_user_option( 'rich_editing' ) ) {
    add_filter( 'mce_external_plugins', 'custom_tinymce_plugin' );
    add_filter( 'mce_buttons', 'register_mce_button' );
  }
}
add_action('admin_head', 'custom_mce_button');

	// Function for new button
function custom_tinymce_plugin( $plugin_array ) {
  $plugin_array['custom_mce_button'] = get_template_directory_uri() .'/js/editor_plugin.js';
  return $plugin_array;
}
// Register new button in the editor
function register_mce_button( $buttons ) {
  array_push( $buttons, 'custom_mce_button' );
  return $buttons;
}

function custom_css_mce_button() {

        $obj= array(
            'TinyMCE_html' => mycity_fmr_icons()
        );
        wp_localize_script('jquery','mycity_obj', $obj);

        wp_enqueue_style('mycity_shortcode_tin',get_template_directory_uri()."/css/admin/shortcode.css");
}
add_action('admin_enqueue_scripts', 'custom_css_mce_button',500);

/**
* @return string
 */
function mycity_fmr_icons(){
   global $mycity_fmr_icon;
            ob_start();
            ?>
            <div id="mycity_icon_content">
				<div class="mycity_icon_block">
                     <b><?php echo esc_html('Trendy icon name','mycity'); ?> </b> <br />


            <?php
             $exclude = array('fmr-icon-114','fmr-icon-268','fmr-icon-2412','fmr-icon-3516','fmr-icon-4412','fmr-icon-69','fmr-icon-340',
                    'fmr-icon-483','fmr-icon-2103','fmr-icon-2104','fmr-icon-2104','fmr-icon-4519');
                foreach ($mycity_fmr_icon as $v) {
                   if(in_array($v,$exclude)) continue;
                  ?>

					<i class="fmr extra_admin_1 <?php echo esc_attr($v); ?>" data-icon="<?php echo esc_html($v); ?>"
                    onclick='jQuery(".extra_admin_1").removeClass("active"); jQuery(this).addClass("active"); '> <?php  ?></i>
				<?php

                }
                ?>
                </div>
                <div class="mycity_icon_block">
                    <br />
                    <b><?php esc_html_e('Font awesome icon name',
                    'mycity'); ?> </b> <br />



                <?php
                global $mycity_fa;
                foreach ($mycity_fa as $v) {
                    ?>
					<i class="extra_admin_1 fa <?php echo esc_attr($v); ?>" data-icon="<?php echo esc_html($v); ?>"
                    onclick='jQuery(".extra_admin_1").removeClass("active"); jQuery(this).addClass("active"); '> <?php  ?></i>
				<?php
                }
                ?>

				 </div>
                </div>

	            <?php
          return ob_get_clean();

}
/*==========================================================vc_map==================================*/
add_action( 'vc_before_init', 'mycity_top_promo_bloc_integrateWithVC');
function  mycity_top_promo_bloc_integrateWithVC(){
if(!function_exists('vc_map')) return;
  vc_map( array(
      "name" => __( "Mycity top promo bloc", 'mycity' ),
      "base" => "mycity_top_promo_bloc",
      "class" => "",
      "category" => __( "Structure", 'mycity'),
      "params" => array(
         array(
            "type" => "textfield",
            "holder" => "div",
            "class" => "",
            "heading" => __( "Text header", 'mycity' ),
            "param_name" => "h",
            "value" => __( "welcome to my city guide!", 'mycity' ),
            "description" => __( "Text header", 'mycity' )
         ),
         array(
            "type" => "textfield",
            "holder" => "div",
            "class" => "",
            "heading" => __( "Description under the heading", 'mycity' ),
            "param_name" => "desc",
            "value" => __( "See and visit interesting places. Share experiences with your friends. Simply", 'mycity' ),
            "description" => __( "Description under the heading.", 'mycity' )
         ),
         array(
            "type" => "textfield",
            "holder" => "div",
            "class" => "",
            "heading" => __( "Text Find", 'mycity' ),
            "param_name" => "find",
            "value" => __( "Find places or events", 'mycity' ),
            "description" => __( "Text Find.", 'mycity' )
         ),

        array(
            "type" => "textfield",
            "holder" => "div",
            "class" => "",
            "heading" => __( "Text Select category", 'mycity' ),
            "param_name" => "sc",
            "value" => __( "Select category", 'mycity' ),
            "description" => __( "Text Select category.", 'mycity' )
         ),
        array(
            "type" => "textfield",
            "holder" => "div",
            "class" => "",
            "heading" => __( "Text button search", 'mycity' ),
            "param_name" => "search",
            "value" => __( "search", 'mycity' ),
            "description" => __( "Text button search", 'mycity' )
         ),


      )
   ) );
}
