<?php

/**
 * @return maps point by term slug
 * @param $terms
 * @param string $ids
 * @return string
 */
function mycity_init_maps_point_by_term_slug($terms, $ids = "")
{
    ob_start();
    $args = array(
        'posts_per_page' => 30000000,
        'post_type' => array(
            'places'
        ),
        'tax_query' => array(array(
            'taxonomy' => 'places_categories',
            'terms' =>  sanitize_text_field($terms),
            'field' => 'id')
        )


);

    if ($ids) {
        $args["post__in"] = $ids;
    }
    $MyCity_pmgm_query = new WP_Query($args);

    $points = array();
    if ($MyCity_pmgm_query->have_posts()):
        while ($MyCity_pmgm_query->have_posts()) {
            $MyCity_pmgm_query->the_post();
            ob_start();
            $cordinats = esc_html(get_post_meta(get_the_ID(), '_myfield', true));
            /*Кординаты*/

            preg_match("/(.*?),(.*?)$/", $cordinats, $math);
			if (!isset($math[1])) continue;
            $location_latitude = esc_attr($math[1]);
            $location_longitude = esc_attr($math[2]);
            if ( strlen($location_latitude) < 5) continue;

            $img = esc_url(get_template_directory_uri()) . "/img/img.png";
            $small_img = esc_url(wp_get_attachment_url(get_post_meta(get_the_ID(), '_small_img', true)));
            $img = esc_html(bfi_thumb($small_img, array('width' => 110, 'height' => 110)));

            ?>

            {
            name: '<?php
            echo esc_html(get_the_title()) ;
            ?>',
            location_latitude: '<?php
            echo esc_html($location_latitude);
            ?>',
            location_longitude:  '<?php
            echo esc_html($location_longitude);
            ?>',
            map_image_url: '<?php
            echo esc_url($img);
            ?>',
            name_point: '<?php
            echo esc_html(get_the_title());
            ?>',
            fa_icon: '<?php echo esc_attr(mycity_get_marker_by_id($terms)); ?>',

            description_point: '<?php
            $out = esc_html(get_the_excerpt());
            $out = iconv_substr($out, 0, 120, 'utf-8'); // $out = "324";
            if(strlen(get_the_title()) < 17)
                echo '<p>' . esc_attr($out) . '</p>';
            ?>',
            url_point: '<?php
            echo esc_url(get_permalink());
            ?>',
			moreinfo: '<?php esc_html_e("More info","mycity"); ?>'
            }
            <?php
            $points[] = ob_get_clean();
        }
    else:
    endif;

    echo implode(",", $points);
    wp_reset_postdata();
    return ob_get_clean();
}

?>